CON
  mode          = %00000100
  baud          = 9_600 
VAR
  byte t_r, ops
  long  stack[10] 
OBJ
  ser   :       "fullduplexserial"
PUB Start(_id, rx, tx, tr, _cmdptr, _datptr)
  ser.start(rx, tx, mode, baud)
  t_r := tr 'Save T/R pin
  dira[t_r] :=  %1 'Set pin to ouput
  cognew(Receive(_id, _cmdptr, _datptr), @stack)
  return
  
PUB Send(_id, cmd, data)
  ops := false 'Stop Receive routine
  outa[t_r] := %1 'Set to transmit
  ser.tx(_id)
  ser.tx(cmd)
  ser.tx(data)
  outa[t_r] := %0 'Set to receive
  ops := true 'Restart Receive routine   
  return

PUB Receive(_id, _cmd, _dat_) | data
  repeat
    repeat until data := _id 'Wait until ID is received
      if ops := false 'See if object is transmiting
        repeat until ops := true
      data := ser.rx
    bytefill(_cmd, ser.rx, 1) 'Copy command
    bytefill(_dat_, ser.rx, 1) 'Copy data
